searchData={"items":[{"type":"task","doc":"Installs usage_rules","title":"mix usage_rules.install","ref":"Mix.Tasks.UsageRules.Install.html"},{"type":"task","doc":"```sh\nmix igniter.install usage_rules\n```","title":"Example - mix usage_rules.install","ref":"Mix.Tasks.UsageRules.Install.html#module-example"},{"type":"task","doc":"Combine the package rules for the provided packages into the provided file, or list/gather all dependencies.","title":"mix usage_rules.sync","ref":"Mix.Tasks.UsageRules.Sync.html"},{"type":"task","doc":"* `--all` - Gather usage rules from all dependencies that have them\n* `--list` - List all dependencies with usage rules. If a file is provided, shows status (present, missing, stale)\n* `--remove` - Remove specified packages from the target file instead of adding them","title":"Options - mix usage_rules.sync","ref":"Mix.Tasks.UsageRules.Sync.html#module-options"},{"type":"task","doc":"Combine specific packages:\n```sh\nmix usage_rules.sync rules.md ash ash_postgres phoenix\n```\n\nGather all dependencies with usage rules:\n```sh\nmix usage_rules.sync rules.md --all\n```\n\nList all dependencies with usage rules:\n```sh\nmix usage_rules.sync --list\n```\n\nCheck status of dependencies against a specific file:\n```sh\nmix usage_rules.sync rules.md --list\n```\n\nRemove specific packages from a file:\n```sh\nmix usage_rules.sync rules.md ash phoenix --remove\n```","title":"Examples - mix usage_rules.sync","ref":"Mix.Tasks.UsageRules.Sync.html#module-examples"},{"type":"module","doc":"Tools for gathering usage rules from dependencies for projects.","title":"UsageRules","ref":"UsageRules.html"},{"type":"extras","doc":"# UsageRules\n\n**UsageRules** is a development tool for Elixir projects that helps gather and consolidate usage rules from dependencies. The package provides Mix tasks to collect documentation from dependencies that have `usage-rules.md` files and combine them into a single rules file for your project.\n\nYou'll note this package itself doesn't have a usage-rules.md. Its a simple tool that likely would not benefit from having a usage-rules.md file.","title":"Home","ref":"readme.html"},{"type":"extras","doc":"1. **Dependency Rules Collection**: Automatically discovers and collects usage rules from dependencies that provide `usage-rules.md` files in their package directory\n2. **Rules Consolidation**: Combines multiple package rules into a single file with proper sectioning and markers\n3. **Status Tracking**: Can list dependencies with usage rules and check if your consolidated file is up-to-date\n4. **Selective Management**: Allows adding/removing specific packages from your rules file","title":"Key Features - Home","ref":"readme.html#key-features"},{"type":"extras","doc":"1. The tool scans your project's dependencies (in `deps/` directory)\n2. Looks for `usage-rules.md` files in each dependency\n3. Consolidates these rules into a target file with special markers like `<-- package-name-start -->` and `<-- package-name-end -->`\n4. Maintains sections that can be updated independently as dependencies change\n\nThis is particularly useful for projects using frameworks like Ash, Phoenix, or other packages that provide specific usage guidelines, coding patterns, or best practices that should be followed consistently across your project.","title":"How It Works - Home","ref":"readme.html#how-it-works"},{"type":"extras","doc":"The main task `Mix.Tasks.UsageRules.Sync` provides several modes of operation:","title":"Usage - Home","ref":"readme.html#usage"},{"type":"extras","doc":"```sh\nmix usage_rules.sync rules.md ash phoenix\n```","title":"Combine specific packages - Home","ref":"readme.html#combine-specific-packages"},{"type":"extras","doc":"```sh\nmix usage_rules.sync rules.md --all\n```","title":"Gather all dependencies with usage rules - Home","ref":"readme.html#gather-all-dependencies-with-usage-rules"},{"type":"extras","doc":"```sh\nmix usage_rules.sync --list\n```","title":"List available packages with usage rules - Home","ref":"readme.html#list-available-packages-with-usage-rules"},{"type":"extras","doc":"```sh\nmix usage_rules.sync rules.md --list\n```","title":"Check status against a file - Home","ref":"readme.html#check-status-against-a-file"},{"type":"extras","doc":"```sh\nmix usage_rules.sync rules.md ash --remove\n```","title":"Remove packages from a file - Home","ref":"readme.html#remove-packages-from-a-file"},{"type":"extras","doc":"","title":"Installation - Home","ref":"readme.html#installation"},{"type":"extras","doc":"`mix igniter.install usage_rules`.\n\nAdd the dependency manually\n\n```elixir\ndef deps do\n  [\n    # should only ever be used as a dev dependency\n    # requires igniter as a dev dependency\n    {:usage_rules, \"~> 0.1\", only: [:dev]},\n    {:igniter, \"~> 0.6\", only: [:dev]}\n  ]\nend\n```","title":"With Igniter - Home","ref":"readme.html#with-igniter"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}